#!/usr/bin/env python3
# -*- coding: utf-8 -*-
from sqlalchemy.orm import Session
from sqlalchemy import text, exists, and_, or_, not_
from sqlalchemy.sql import func
from database import get_db
from models import *
from extensions import logger
from utils import *

def get_plan_name_by_id(db: Session, plan_id: int) -> str:
    row = db.query(EmergencyPlan).filter(EmergencyPlan.id == plan_id).first()
    if row is not None:
        return row.plan_name
    
    return ''

def get_plan_file_list(db: Session, plan_number: str):
    row = db.query(EmergencyPlan).filter(EmergencyPlan.plan_number == plan_number).first()
    if row is None:
        return []

    plan_id = row.plan_id
    file_query = db.query(EmergencyFile)
    file_query = file_query.filter(EmergencyFile.del_flag != '2')
    file_query = file_query.filter(EmergencyFile.from_scenario == 'emergencyPlans_plan')
    file_query = file_query.filter(EmergencyFile.foreign_key == plan_id)
    files = file_query.all()
    result = [{
        "uid": file.file_id,
        "status": file.status,
        "name": file.file_name_desc,
        "url":  file.file_name
    } for file in files]
    return result