#!/usr/bin/env python3
# -*- coding: utf-8 -*-
from fastapi import APIRouter, Depends
from common.security import valid_access_token
from routers.api import upload_file
from . import system
from . import auth
from . import zwrz
from . import sso

router = APIRouter()

router.include_router(auth.router, prefix="/auth")

router.include_router(system.router, prefix="/system")#, dependencies=[Depends(valid_access_token)])

router.include_router(upload_file.router, prefix="/file")

router.include_router(zwrz.router)

router.include_router(sso.router, prefix="/sso")